VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CRUFL"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function WideCharToMultiByte _
                Lib "kernel32.dll" (ByVal CodePage As Long, _
                                    ByVal dwFlags As Long, _
                                    ByRef lpWideCharStr As Any, _
                                    ByVal cchWideChar As Long, _
                                    ByRef lpMultiByteStr As Any, _
                                    ByVal cchMultiByte As Long, _
                                    ByRef lpDefaultChar As Any, _
                                    ByRef lpUsedDefaultChar As Any) As Long

Private Const CP_UTF8 As Long = 65001

Private Function RemoveSpecialCharacter(sVal As String) As String

    On Error GoTo RemoveSpecialCharacterErrorHandler

    Dim sReturn As String
    
    If InStr(sVal, "http://") > 0 Or InStr(sVal, "https://") > 0 Then
        sVal = Replace(sVal, "http://", "")
        sVal = Replace(sVal, "https://", "")

        If Right$(sVal, 1) = "/" Then
            sVal = Left$(sVal, Len(sVal) - 1)
        End If
    End If
    
    sReturn = Replace(sVal, "\", "#")
    sReturn = Replace(sReturn, "/", "~")
    sReturn = Replace(sReturn, "*", "@")
    sReturn = Replace(sReturn, ":", "$")
    sReturn = Replace(sReturn, "?", "%")
    sReturn = Replace(sReturn, """", "^")
    sReturn = Replace(sReturn, "<", "&")
    sReturn = Replace(sReturn, ">", "-")
    sReturn = Replace(sReturn, "|", "+")
    
    RemoveSpecialCharacter = sReturn
    
    Exit Function

RemoveSpecialCharacterErrorHandler:
    MsgBox Err.Description
End Function

Public Function Encode(sPath As String, sStr As String) As String

    On Error GoTo EncodeErrorHandler

    Dim b2()      As Byte

    Dim i         As Long, m As Long

    Dim sFileName As String

    Dim sFilePath As String

    Dim obj       As New clsQRCode

    sFileName = sStr
    sFileName = RemoveSpecialCharacter(sFileName)

    If Len(sFileName) >= 100 Then
        sFileName = Left$(sFileName, 100)
    End If
    
    sFilePath = sPath & "\QRImage" & "\" & sFileName & ".png"

    If Dir(sFilePath) = "" Then
        If Dir(sPath & "\QRImage", vbDirectory) = "" Then
            If Dir(sPath, vbDirectory) = "" Then
                MkDir sPath
            End If

            MkDir sPath & "\QRImage"
        End If
    
        m = Len(sStr)
        i = m * 3 + 64
        ReDim b2(i)
        m = WideCharToMultiByte(CP_UTF8, 0, ByVal StrPtr(sStr), m, b2(0), i, ByVal 0, ByVal 0)
            
        SavePicture obj.Encode(b2, m, 0, 2, -1), sFilePath
    End If

    Encode = sFilePath

    Exit Function

EncodeErrorHandler:
    MsgBox Err.Description
End Function
