Attribute VB_Name = "modOpen"
Option Explicit

Public Declare Function GetOpenFileName _
               Lib "comdlg32.dll" _
               Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long

Type OPENFILENAME

    lStructSize As Long
    hWndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    Flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String

End Type

Private Const LPTR = (&H0 Or &H40)

Private Declare Function LocalAlloc _
                Lib "kernel32" (ByVal uFlags As Long, _
                                ByVal uBytes As Long) As Long

Private Declare Sub CopyMemory _
                Lib "kernel32" _
                Alias "RtlMoveMemory" (pDest As Any, _
                                       pSource As Any, _
                                       ByVal dwLength As Long)

Public Type BrowseInfo

    hWndOwner As Long
    pIDLRoot As Long
    pszDisplayName As Long
    lpszTitle As Long
    ulFlags As Long
    lpfnCallback As Long
    lParam As Long
    iImage As Long

End Type

Private Const BIF_RETURNONLYFSDIRS = 1

Private Const MAX_PATH = 260

Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal hMem As Long)

Private Declare Function lstrcat _
                Lib "kernel32" _
                Alias "lstrcatA" (ByVal lpString1 As String, _
                                  ByVal lpString2 As String) As Long

Private Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long

Private Declare Function SHGetPathFromIDList _
                Lib "shell32" (ByVal pidList As Long, _
                               ByVal lpBuffer As String) As Long

'ļ
Private Declare Function MakeSureDirectoryPathExists _
                Lib "imagehlp.dll" (ByVal dirpath As String) As Long

'ɾļ
Declare Function DeleteFile _
        Lib "kernel32" _
        Alias "DeleteFileA" (ByVal lpFilename As String) As Long

'---------------------------------------------------------------ӳļAPI------------------------------------------------------------
Private Declare Function WNetAddConnection2 _
                Lib "mpr.dll" _
                Alias "WNetAddConnection2A" (lpNetResource As NETRESOURCE, _
                                             ByVal lpPassword As String, _
                                             ByVal lpUserName As String, _
                                             ByVal dwFlags As Long) As Long

Private Declare Function WNetCancelConnection2 _
                Lib "mpr.dll" _
                Alias "WNetCancelConnection2A" (ByVal lpName As String, _
                                                ByVal dwFlags As Long, _
                                                ByVal fForce As Long) As Long

Private Type NETRESOURCE 'Զṹ

    dwScope As Long
    dwType As Long
    dwDisplayType As Long
    dwUsage As Long
    lpLocalName As String
    lpRemoteName As String
    lpComment As String
    lpProvider As String

End Type

Const NO_ERROR = 0   '

Const CONNECT_UPDATE_PROFILE = &H1

Const RESOURCETYPE_DISK = &H1

Const RESOURCETYPE_PRINT = &H2

Const RESOURCETYPE_ANY = &H0

Const RESOURCE_CONNECTED = &H1

Const RESOURCE_REMEMBERED = &H3

Const RESOURCE_GLOBALNET = &H2

Const RESOURCEDISPLAYTYPE_DOMAIN = &H1

Const RESOURCEDISPLAYTYPE_GENERIC = &H0

Const RESOURCEDISPLAYTYPE_SERVER = &H2

Const RESOURCEDISPLAYTYPE_SHARE = &H3

Const RESOURCEUSAGE_CONNECTABLE = &H1

Const RESOURCEUSAGE_CONTAINER = &H2

'--------------------------------------------------------------------------------------------------------------------------------------------------------

Private Declare Function ShellExecute _
                Lib "shell32.dll" _
                Alias "ShellExecuteA" (ByVal hWnd As Long, _
                                       ByVal lpOperation As String, _
                                       ByVal lpFile As String, _
                                       ByVal lpParameters As String, _
                                       ByVal lpDirectory As String, _
                                       ByVal nShowCmd As Long) As Long

'---------------------------------------------------------------ȡǰ¼û------------------------------------------------------------
Private Declare Function GetUserName _
                Lib "advapi32.dll" _
                Alias "GetUserNameA" (ByVal lpBuffer As String, _
                                      nSize As Long) As Long

'--------------------------------------------------------------------------------------------------------------------------------------------------------
Public Declare Function GetPrivateProfileString _
               Lib "kernel32" _
               Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As Any, _
                                                 ByVal lpKeyName As Any, _
                                                 ByVal lpDefault As String, _
                                                 ByVal lpReturnedString As String, _
                                                 ByVal nSize As Long, _
                                                 ByVal lpFilename As String) As Long

Public Declare Function WritePrivateProfileString _
               Lib "kernel32" _
               Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, _
                                                   ByVal lpKeyName As Any, _
                                                   ByVal lpString As Any, _
                                                   ByVal lpFilename As String) As Long

Private Declare Function FindWindow _
                Lib "user32" _
                Alias "FindWindowA" (ByVal lpClassName As String, _
                                     ByVal lpWindowName As String) As Long

Private Declare Function SetForegroundWindow Lib "user32" (ByVal hWnd As Long) As Long

'жϴǷ
Public Function findWindowByName(windowName As String) As Long

    Dim hWnd As Long

    hWnd = FindWindow("CabinetWClass", windowName) 'ļдھ
    findWindowByName = hWnd
End Function

'жϴǷ,ھͼھʹ
Public Sub findWindowAndOpen(windowPath As String)

    Dim hWnd       As Long

    Dim windowName As String
    
    windowName = Right$(windowPath, Len(windowPath) - InStrRev(windowPath, "\"))
    hWnd = FindWindow("CabinetWClass", windowName) 'ļдھ

    If hWnd <> 0 Then
        SetForegroundWindow hWnd
    Else
        Shell "explorer.exe /n, /e," & windowPath, vbNormalFocus
    End If

End Sub

'ļ
Public Sub makeDir(pathStr As String)

    If Right$(pathStr, 1) <> "\" Then
        pathStr = pathStr & "\"
    End If

    MakeSureDirectoryPathExists pathStr
End Sub

'ɾļ
Public Sub delFile(pathStr As String)
    DeleteFile pathStr
End Sub

'Ϣtxtļ
Public Sub WriteMsgToFile(pcErrMsg As String, Optional filePath As String)

    Dim loFs       As FileSystemObject

    Dim lcFileName As String

    Dim lnHandle
 
    Set loFs = CreateObject("Scripting.FileSystemObject")

    If filePath = "" Then
        Set lnHandle = loFs.OpenTextFile(App.Path & "\list.txt", ForAppending, True)
    Else
        Set lnHandle = loFs.OpenTextFile(filePath, ForAppending, True)
    End If
    
    lnHandle.WriteLine pcErrMsg
    lnHandle.Close
End Sub

'ѡļ
Public Function getFile() As String

    Dim filePath As String

    Dim ofn      As OPENFILENAME

    Dim rtn      As String
    
    ofn.lStructSize = Len(ofn)
    '    ofn.hwndOwner = Me.hwnd
    ofn.hInstance = App.hInstance
    ofn.lpstrFilter = "ALL Files" & vbNullChar & "*.*"
    ofn.lpstrFile = Space(254) 'ԸһĬϵļ
    ofn.nMaxFile = 255
    ofn.lpstrFileTitle = Space(254)
    ofn.nMaxFileTitle = 255
    '    ofn.lpstrInitialDir = App.Path
    ofn.lpstrTitle = "ѡļ"
    ofn.Flags = 6148
    rtn = GetOpenFileName(ofn)
  
    If rtn >= 1 Then
        getFile = ofn.lpstrFile
    Else
        getFile = ""
    End If

End Function

'ѡļ
Public Function getFolder(hWndOwner As Long, _
                          sPrompt As String, _
                          Optional defaulrPath As String = "C:\") As String

    '
    Dim iNull    As Integer

    Dim lpIDList As Long

    Dim lResult  As Long

    Dim sPath    As String

    Dim udtBI    As BrowseInfo

    '    Dim Ret     As Long

    '    defaulrPath = "F://ͨ/inno/ϰ/ļ"
    '    Ret = LocalAlloc(LPTR, VBA.Len(defaulrPath) + 1)
    '    CopyMemory ByVal Ret, ByVal defaulrPath, VBA.Len(defaulrPath) + 1

    'ʼ.....
    With udtBI
        .hWndOwner = hWndOwner
        .lpszTitle = lstrcat(sPrompt, "")
        .ulFlags = BIF_RETURNONLYFSDIRS
        '        .lParam = Ret
    End With

    'API
    lpIDList = SHBrowseForFolder(udtBI)

    'õؽ
    If lpIDList Then
        sPath = String$(MAX_PATH, 0)
        lResult = SHGetPathFromIDList(lpIDList, sPath)
        Call CoTaskMemFree(lpIDList)
        iNull = InStr(sPath, vbNullChar)

        If iNull Then sPath = Left$(sPath, iNull - 1)
    End If

    getFolder = sPath

End Function

'жļļ 1ļ 2ļ
Public Function dirOrfolder(pathStr As String) As Integer

    Dim resultI As Integer

    On Error GoTo myErr
    
    If GetAttr(pathStr) And vbDirectory Then
        resultI = 2
    Else
        resultI = 1
    End If

    dirOrfolder = resultI

    Exit Function

myErr:
    dirOrfolder = 0

    Exit Function

End Function

'жļǷ
Public Function FileExists(ByVal File As String) As Boolean

    On Error Resume Next

    If (GetAttr(File) And vbDirectory) = False Then FileExists = True

    If Err Then FileExists = False: Err.Clear

End Function

'жļǷ
Public Function FolderExists(ByVal Folder As String) As Boolean

    On Error Resume Next

    If GetAttr(Folder) And vbDirectory Then FolderExists = True

    If Err Then FolderExists = False: Err.Clear

End Function

'ȡIP
Public Function getIP() As String

    Dim strComputer As String

    Dim objWMI      As Object

    Dim colIP       As Object

    Dim IP          As Object

    Dim ipStr       As String

    On Error Resume Next

    Dim i As Integer
   
    strComputer = "."
    Set objWMI = GetObject("winmgmts://" & strComputer & "/root/cimv2")
    Set colIP = objWMI.ExecQuery("Select * from Win32_NetworkAdapterConfiguration where IPEnabled=TRUE")
    
    For Each IP In colIP

        If Not IsNull(IP.IPAddress) Then
            ipStr = ipStr & "ͣ" & IP.Description(0) & "," & "ַ" & IP.IPAddress(0) & "/"
        End If

        '        If Not IsNull(IP.IPAddress) Then
        '            ipStr = IP.IPAddress(0)
        '
        '            Exit For
        '
        '        End If

    Next

    getIP = ipStr

    '  For Each IP In colIP
    '    If Not IsNull(IP.IPAddress) Then
    '     For I = LBound(IP.IPAddress) To UBound(IP.IPAddress)
    '       MsgBox "IP  ַ:" & IP.IPAddress(I) & Chr(10) & _
    '       "W:" & IP.Description(I) & Chr(10) & _
    '       "Wַ:" & IP.Macaddress(I)
    '     Next
    '    End If
    '  Next

End Function

'ӳļ
Public Function conDir(rName As String, _
                       userName As String, _
                       userPwd As String, _
                       Optional lName As String = "z:") As String

    Dim NetS      As NETRESOURCE

    Dim errCode   As Long
    
    Dim resultStr As String

    NetS.dwScope = RESOURCE_GLOBALNET   'ҪӵԴ
    NetS.dwType = RESOURCETYPE_ANY
    NetS.dwDisplayType = RESOURCEDISPLAYTYPE_SHARE
    NetS.dwUsage = RESOURCEUSAGE_CONNECTABLE
    NetS.lpLocalName = lName
    NetS.lpRemoteName = rName
    errCode = WNetAddConnection2(NetS, userPwd, userName, CONNECT_UPDATE_PROFILE) 'ú
    
    If errCode <> NO_ERROR Then
        disConDir lName
        errCode = WNetAddConnection2(NetS, userPwd, userName, CONNECT_UPDATE_PROFILE)
    End If

    If errCode = NO_ERROR Then
        resultStr = ""
        '        MsgBox "ӳɹ!", vbInformation, "ӳϢʾ"
    Else
        resultStr = "ӳʧ"
        '        MsgBox "ִ" & Err.Description & " - ӳʧ!", vbExclamation, "ӳϢʾ"
    End If

    conDir = resultStr
End Function

'Ͽӳ
Public Function disConDir(Optional lName As String = "z:") As String

    Dim Err1      As Long

    Dim str       As String

    Dim resultStr As String

    str = lName
    Err1 = WNetCancelConnection2(str, CONNECT_UPDATE_PROFILE, False) 'ú

    If Err1 = NO_ERROR Then
        resultStr = ""
        '        MsgBox "ѾɹϿӳ!", vbInformation, "Ͽ"   'ʾϢ
    Else
        resultStr = "Ͽʧ"
        '        MsgBox "ִ " & Err.Description & " - Ͽʧ!", vbExclamation, "ϿϢʾ" 'ʾϢ
    End If

    disConDir = resultStr
End Function

'ָļ
Public Sub openDir(hWnd As Long, ByVal dirpath As String)
    ShellExecute hWnd, "open", dirpath, vbNullString, vbNullString, 5
End Sub

'ȡǰϵͳû
Public Function getCurUserName() As String

    Dim st  As String * 100

    Dim pln As Long

    pln = 99

    GetUserName st, pln
    getCurUserName = Left$(st, pln)
    
    'Dim lngLen As Long, lngRet As Long, strRet As String
    '
    'lngLen = &H400: lngRet = 0: strRet = Space$(lngLen)
    '
    'lngRet = GetUserName(strRet, lngLen)
    '
    'If lngRet = 0 Then
    '    getCurUserName = ""
    'Else
    '    getCurUserName = Left$(strRet, lngLen)
    'End If
End Function

'ȡiniļڵ
Public Function ReadIni(strPath As String, _
                        strlpApplicationName As String, _
                        strKeyName As String) As String

    Dim keyValue As String

    keyValue = Space(256)
    GetPrivateProfileString strlpApplicationName, strKeyName, "", keyValue, 256, strPath
    ReadIni = Trim(keyValue)
    ReadIni = Mid(ReadIni, 1, Len(ReadIni) - 1)
End Function

'дiniļڵ
Public Function WriteIni(ByRef strPath As String, _
                         ByVal section As String, _
                         ByVal key As String, _
                         ByVal value As String) As Boolean

    Dim x As Long, buff As String * 256, i As Integer

    '    If Dir(strPath) <> "" Then
    buff = value + Chr(0)
    x = WritePrivateProfileString(section, key, buff, strPath)

    If Err.Number = 0 Then
        WriteIni = True
    Else
        WriteIni = False
    End If

    '    Else
    '        WriteIni = False
    '    End If

End Function

'sqlserverݿ
'ܣִ
'strServerName , strUserNameû, strPassword , strdbnameݿ,sqlTypeݿ 1 sqlserver 2 localdb
'أַ
Public Function genSQLConStr(strServerName As String, _
                             strUserName As String, _
                             strpassword As String, _
                             strDbname As String, _
                             Optional sqlType As Integer) As String

    Dim resultStr As String

    If sqlType <> 2 Then
        resultStr = "Provider=SQLOLEDB.1;Password=" & strpassword & ";Persist Security Info=False;User ID=" & strUserName & ";Initial Catalog=" & strDbname & ";Data Source=" & strServerName
    Else
        resultStr = "Provider=SQLNCLI11.0;Integrated Security=SSPI;Initial Catalog=" & strDbname & ";Persist Security Info=true;Data Source=(localdb)\MSSQLLocalDB"
    End If

    genSQLConStr = resultStr
End Function

'ܣaccessִ
'filePath ļ·, pwdStr ļ
'أַ
Public Function getAccessConStr(Optional filePath As String, Optional pwdStr As String)

    Dim resultStr As String
    
    resultStr = ""
    
    If filePath = "" Then
        filePath = App.Path & "\question.mdb"
    End If
    
    If pwdStr = "" Then
        pwdStr = "6689036"
    End If
    
    resultStr = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & filePath & ";Jet OLEDB:Database Password=" & pwdStr & ";admin "
    
    getAccessConStr = resultStr

End Function

'ȡʱĿ¼
Public Function getTmpPath() As String

    Dim tmpPath As String

    tmpPath = Environ("temp")
    tmpPath = tmpPath & "\selfTools"

    If FolderExists(tmpPath) = False Then
        makeDir tmpPath
    End If

    getTmpPath = tmpPath
End Function

'ͷԴļ
Public Function UnRes(ByVal ResID As Integer, _
                      ByVal ResName As String, _
                      ByVal UnResPath As String)

    Dim Temp() As Byte

    Temp = LoadResData(ResID, ResName)
    Open UnResPath For Binary As #1
    Put #1, , Temp()
    Close #1
End Function
