Attribute VB_Name = "modRegedit"

Public Declare Function RegOpenKey _
               Lib "advapi32.dll" _
               Alias "RegOpenKeyA" (ByVal hKey As Long, _
                                    ByVal lpSubKey As String, _
                                    phkResult As Long) As Long

Public Declare Function RegEnumValue _
               Lib "advapi32.dll" _
               Alias "RegEnumValueA" (ByVal hKey As Long, _
                                      ByVal dwIndex As Long, _
                                      ByVal lpValueName As String, _
                                      lpcbValueName As Long, _
                                      ByVal lpReserved As Long, _
                                      lpType As Long, _
                                      lpData As Byte, _
                                      lpcbData As Long) As Long

Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

Public Declare Function RegCreateKey _
               Lib "advapi32.dll" _
               Alias "RegCreateKeyA" (ByVal hKey As Long, _
                                      ByVal lpSubKey As String, _
                                      phkResult As Long) As Long

Public Declare Function RegQueryValueEx _
               Lib "advapi32.dll" _
               Alias "RegQueryValueExA" (ByVal hKey As Long, _
                                         ByVal lpValueName As String, _
                                         ByVal lpReserved As Long, _
                                         lpType As Long, _
                                         lpData As Any, _
                                         lpcbData As Long) As Long

Public Declare Function RegEnumKeyEx _
               Lib "advapi32.dll" _
               Alias "RegEnumKeyExA" (ByVal hKey As Long, _
                                      ByVal dwIndex As Long, _
                                      ByVal lpName As String, _
                                      lpcbName As Long, _
                                      ByVal lpReserved As Long, _
                                      ByVal lpClass As String, _
                                      lpcbClass As Long, _
                                      lpftLastWriteTime As Any) As Long

Public Declare Function RegSetValueEx _
               Lib "advapi32.dll" _
               Alias "RegSetValueExA" (ByVal hKey As Long, _
                                       ByVal lpValueName As String, _
                                       ByVal Reserved As Long, _
                                       ByVal dwType As Long, _
                                       lpData As Any, _
                                       ByVal cbData As Long) As Long

Public Declare Function RegDeleteValue _
               Lib "advapi32.dll" _
               Alias "RegDeleteValueA" (ByVal hKey As Long, _
                                        ByVal lpValueName As String) As Long

Public Declare Function RegDeleteKey _
               Lib "advapi32.dll" _
               Alias "RegDeleteKeyA" (ByVal hKey As Long, _
                                      ByVal lpSubKey As String) As Long

Public Const HKEY_CLASSES_ROOT = &H80000000

Public Const HKEY_CURRENT_USER = &H80000001

Public Const HKEY_LOCAL_MACHINE = &H80000002

Public Const HKEY_USERS = &H80000003

Private Const REG_SZ = 1&

Private Const REG_EXPAND_SZ = 2&

Private Const REG_BINARY = 3&

Private Const REG_DWORD = 4&

Private Const ERROR_SUCCESS = 0&

'==================================================
'================================
'ע
'================================
'ȡעֵַ
Public Function GetString(hKey As Long, strPath As String, strValue As String) As String

    Dim keyhand      As Long

    Dim lResult      As Long

    Dim strBuf       As String

    Dim lDataBufSize As Long

    Dim intZeroPos   As Integer

    Dim lValueType   As Long 'new add

    RegOpenKey hKey, strPath, keyhand
    lResult = RegQueryValueEx(keyhand, strValue, 0&, lValueType, ByVal 0&, lDataBufSize)

    If lValueType = REG_SZ Or lValueType = REG_EXPAND_SZ Then
        strBuf = String(lDataBufSize, " ")
        lResult = RegQueryValueEx(keyhand, strValue, 0&, lValueType, ByVal strBuf, lDataBufSize)

        If lResult = ERROR_SUCCESS Then
            intZeroPos = InStr(strBuf, Chr$(0))

            If intZeroPos > 0 Then
                GetString = Left$(strBuf, intZeroPos - 1)
                Else: GetString = strBuf
            End If
        End If
    End If

End Function

'дעֵַ
Public Function SetString(hKey As Long, _
                          strPath As String, _
                          strValue As String, _
                          strdata As String) As Long

    Dim keyhand    As Long

    Dim resultLong As Long

    RegCreateKey hKey, strPath, keyhand
    resultLong = RegSetValueEx(keyhand, strValue, 0, REG_SZ, ByVal strdata, Len(strdata) * 2)
    RegCloseKey keyhand
    SetString = resultLong
End Function

'ȡע DWORD ֵ
Function GetDword(ByVal hKey As Long, _
                  ByVal strPath As String, _
                  ByVal strValueName As String) As Long

    Dim lResult      As Long

    Dim lValueType   As Long

    Dim lBuf         As Long

    Dim lDataBufSize As Long

    Dim r            As Long

    Dim keyhand      As Long

    r = RegOpenKey(hKey, strPath, keyhand)
    ' Get length/data type
    lDataBufSize = 4
    lResult = RegQueryValueEx(keyhand, strValueName, 0&, lValueType, lBuf, lDataBufSize)

    If lResult = ERROR_SUCCESS Then
        If lValueType = REG_DWORD Then
            GetDword = lBuf
        End If

        'Else
        ' Call errlog("GetDWORD-" & strPath, False)
    End If

    r = RegCloseKey(keyhand)
End Function

'дע DWORD ֵ
Function SetDword(ByVal hKey As Long, _
                  ByVal strPath As String, _
                  ByVal strValueName As String, _
                  ByVal lData As Long)

    Dim keyhand As Long

    RegCreateKey hKey, strPath, keyhand
    RegSetValueEx keyhand, strValueName, 0&, REG_DWORD, lData, 4
    RegCloseKey keyhand
End Function

'ȡעƼֵ
Function GetBinary(ByVal hKey As Long, _
                   ByVal strPath As String, _
                   ByVal strValueName As String) As Long

    Dim lResult      As Long

    Dim lValueType   As Long

    Dim lBuf         As Long

    Dim lDataBufSize As Long

    Dim r            As Long

    Dim keyhand      As Long

    r = RegOpenKey(hKey, strPath, keyhand)
    ' Get length/data type
    lDataBufSize = 4
    lResult = RegQueryValueEx(keyhand, strValueName, 0&, lValueType, lBuf, lDataBufSize)

    If lResult = ERROR_SUCCESS Then
        If lValueType = REG_BINARY Then
            GetBinary = lBuf
        End If
    End If

    r = RegCloseKey(keyhand)
End Function

'дעƼֵ
Function SetBinary(ByVal hKey As Long, _
                   ByVal strPath As String, _
                   ByVal strValueName As String, _
                   ByVal lData As Long, _
                   ByVal BitNumber As Long)

    Dim keyhand As Long

    RegCreateKey hKey, strPath, keyhand
    RegSetValueEx keyhand, strValueName, 0&, REG_BINARY, lData, BitNumber
    RegCloseKey keyhand
End Function

'ɾһעֵ
Public Function DeleteValue(ByVal hKey As Long, _
                            ByVal strPath As String, _
                            ByVal strValue As String) As Long

    Dim keyhand    As Long

    Dim resultLong As Long

    RegOpenKey hKey, strPath, keyhand
    resultLong = RegDeleteValue(keyhand, strValue)
    RegCloseKey keyhand
    DeleteValue = resultLong
End Function

'һ
Public Function CreateKey(ByVal hKey As Long, ByVal strKey As String)

    Dim keyhand&

    RegCreateKey hKey, strKey, keyhand
    RegCloseKey keyhand&
End Function




